#
# Copyright (c) 2008-2015 Thierry Florac <tflorac AT ulthar.net>
# All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.
#

__docformat__ = 'restructuredtext'


# import standard library

# import interfaces
from pyams_pagelet.interfaces import IPagelet
from pyams_portal.interfaces import IPortletPreviewer
from pyams_portal.portlets.context.interfaces import IContextPortletConfiguration
from pyams_skin.layer import IPyAMSLayer

# import packages
from pyams_form.form import AJAXEditForm
from pyams_pagelet.pagelet import pagelet_config
from pyams_portal.portlet import PortletPreviewer
from pyams_portal.zmi.portlet import PortletConfigurationEditor
from pyams_template.template import template_config
from pyams_utils.adapter import adapter_config
from zope.interface import Interface


@pagelet_config(name='properties.html', context=IContextPortletConfiguration, request_type=IPyAMSLayer,
                permission='system.view')
class ContextPortletConfigurationEditor(PortletConfigurationEditor):
    """Context portlet configuration editor"""

    interface = IContextPortletConfiguration


@adapter_config(name='properties.json', context=(IContextPortletConfiguration, IPyAMSLayer), provides=IPagelet)
class ContextPortletConfigurationAJAXEditor(AJAXEditForm, ContextPortletConfigurationEditor):
    """Context portlet configuration editor, AJAX renderer"""


@adapter_config(context=(Interface, IPyAMSLayer, Interface, IContextPortletConfiguration),
                provides=IPortletPreviewer)
@template_config(template='templates/context-preview.pt', layer=IPyAMSLayer)
class ContextPortletPreviewer(PortletPreviewer):
    """Context portlet previewer"""
